#ifndef __GENERAL_H
#define __GENERAL_H

// =====================
// !!!!! IMPORTANT !!!!!
// =====================
// Only one defenition
// can be present here.
// One of them is:
// ---------------------
//#define MCLV2
#define MD35
// =====================

#ifdef __cplusplus
extern "C" {
#endif

#define FCY 90000000U

#include <stdint.h>

typedef uint8_t     u08;
typedef uint16_t    u16;
typedef uint32_t    u32;
typedef uint64_t    u64;

typedef int8_t      s08;
typedef int16_t     s16;
typedef int32_t     s32;
typedef int64_t     s64;

typedef struct {
    uint8_t symbol;           // Byte
    int8_t phases[4];         // Phases (0..3)
    
    uint8_t phase_index:2;    // Current index of phase (0..3)
    uint8_t is_completed:1;   // 
    uint8_t is_calculated:1;  // 
    uint8_t : 4;
} QPSK_T;

#define Q15(Float_Value)	\
((Float_Value < 0.0) ? (int16_t)(32768 * (Float_Value) - 0.5) \
: (int16_t)(32767 * (Float_Value) + 0.5))

int16_t Q15SQRT(int16_t );

#ifdef __cplusplus  // Provide C++ Compatibility
    }
#endif

#endif      // end of general_H
